void gibbs1_effect(Y, BACK, STATY, line)
int **Y, **BACK, line; 
double *STATY;
{
	int i, j, k, **M1DATA, **M2DATA;
	double *M1STAT, *M2STAT, num, denom, pr, u;
	
	M1DATA = imatrix(0, 3, 0, TOOTH+1);
	M2DATA = imatrix(0, 3, 0, TOOTH+1);
	
	M1STAT = dvector(1, nPARA1 + nCOEF1 + 1);
	M2STAT = dvector(1, nPARA1 + nCOEF1 + 1);
	
	for(i = 0; i <= 3; i++)
		for(j = 0; j <= TOOTH + 1; j++) M1DATA[i][j] = M2DATA[i][j] = Y[i][j];
	
	for(i = 1; i <= 2; i++)
		for(j = 1; j <= TOOTH; j++)
			if(BACK[i][j] == 1) {
				for(k = 1; k <= nPARA1 + nCOEF1 + 1; k++) M1STAT[k] = M2STAT[k] = 0.0;
				M1DATA[i][j] =  1; cost1(M1DATA, BACK, M1STAT, line);
				M2DATA[i][j] = -1; cost1(M2DATA, BACK, M2STAT, line);

				for(num = 0.0, k = 1; k <= nPARA1 + nCOEF1; k++) num += theta_A[k] * (M2STAT[k] - M1STAT[k]);
				num += neweffect_A[line] * (M2STAT[(nPARA1+nCOEF1+1)] - M1STAT[(nPARA1+nCOEF1+1)]);
				denom = 1.0 + exp(num); pr = 1.0 / denom;
				
				u = 0.0; while(u <= 0.0 || u >= 1.0) u = rand() * 1.0 / RAND_MAX;
				if(u < pr) M1DATA[i][j] = M2DATA[i][j] = Y[i][j] = 1;
				else M1DATA[i][j] = M2DATA[i][j] = Y[i][j] = -1;
			}
	
	for(k = 1; k <= nPARA1 + nCOEF1 + 1; k++) STATY[k] = 0.0;
	cost1(Y, BACK, STATY, line);
	Yeffstat_A[line] = STATY[(nPARA1+nCOEF1+1)];
	
	free_imatrix(M1DATA, 0, 3, 0, TOOTH+1);
	free_imatrix(M2DATA, 0, 3, 0, TOOTH+1);
	
	free_dvector(M1STAT, 1, nPARA1 + nCOEF1 + 1);
	free_dvector(M2STAT, 1, nPARA1 + nCOEF1 + 1);
	
	return;
}
